regina::NLayeredLensSpace Class Reference
Standard Triangulations and Subcomplexes

Represents a layered lens space component of a triangulation. More...

`#include <subcomplex/nlayeredlensspace.h>`

Inheritance diagram for regina::NLayeredLensSpace:

## Public Member Functions

virtual | ~NLayeredLensSpace ()
| Destroys this lens space; note that the corresponding layered solid torus will also be destroyed. More...
NLayeredLensSpace * | clone () const
| Returns a newly created clone of this structure. More...
unsigned long | getP () const
| Returns the first parameter p of this lens space L(p,q). More...
unsigned long | getQ () const
| Returns the second parameter q of this lens space L(p,q). More...
const NLayeredSolidTorus & | getTorus () const
| Returns the layered solid torus to which the mobius strip is glued. More...
int | getMobiusBoundaryGroup () const
| Determines which edge of the layered solid torus is glued to the boundary of the mobius strip (i.e., the weight 2 edge of the degenerate (2,1,1) layered solid torus). More...
bool | isSnapped () const
| Determines if the layered solid torus that forms the basis for this lens space is snapped shut (folded closed without a twist). More...
bool | isTwisted () const
| Determines if the layered solid torus that forms the basis for this lens space is twisted shut (folded closed with a twist). More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NLayeredLensSpace * | isLayeredLensSpace (const NComponent *comp)
| Determines if the given triangulation component is a layered lens space. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a layered lens space component of a triangulation.

A layered lens space is considered to be any layered solid torus glued to a degenerate (2,1,1) layered solid torus (i.e., a one-triangle mobius strip). Note that the three possible gluing options represent the three possible ways of closing the initial torus - either twisting it shut (in one of two possible ways) or snapping it shut without any twist.

A layered lens space must contain at least one tetrahedron.

All optional NStandardTriangulation routines are implemented for this class.

Test:
  Included in the test suite.

## Constructor & Destructor Documentation

regina::NLayeredLensSpace::~NLayeredLensSpace | ( |  | ) |

inline virtual

Destroys this lens space; note that the corresponding layered solid torus will also be destroyed.

## Member Function Documentation

NLayeredLensSpace* regina::NLayeredLensSpace::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

NAbelianGroup* regina::NLayeredLensSpace::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

NManifold* regina::NLayeredLensSpace::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

int regina::NLayeredLensSpace::getMobiusBoundaryGroup | ( |  | ) | const

inline

Determines which edge of the layered solid torus is glued to the boundary of the mobius strip (i.e., the weight 2 edge of the degenerate (2,1,1) layered solid torus).

The return value will be one of the three top level tetrahedron edge groups in the layered solid torus; see NLayeredSolidTorus::getTopEdge() for further details about edge groups.

Returns
  the top level edge group of the layered solid torus to which the mobius strip boundary is glued.

unsigned long regina::NLayeredLensSpace::getP | ( |  | ) | const

inline

Returns the first parameter p of this lens space L(p,q).

Returns
  the first parameter p.

unsigned long regina::NLayeredLensSpace::getQ | ( |  | ) | const

inline

Returns the second parameter q of this lens space L(p,q).

Returns
  the second parameter q.

const NLayeredSolidTorus & regina::NLayeredLensSpace::getTorus | ( |  | ) | const

inline

Returns the layered solid torus to which the mobius strip is glued.

Returns
  the layered solid torus.

static NLayeredLensSpace* regina::NLayeredLensSpace::isLayeredLensSpace | ( | const NComponent * | comp | ) |

static

Determines if the given triangulation component is a layered lens space.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the layered lens space, or `null` if the given component is not a layered lens space.

bool regina::NLayeredLensSpace::isSnapped | ( |  | ) | const

inline

Determines if the layered solid torus that forms the basis for this lens space is snapped shut (folded closed without a twist).

Returns
  `true` if and only if the torus is snapped shut.

bool regina::NLayeredLensSpace::isTwisted | ( |  | ) | const

inline

Determines if the layered solid torus that forms the basis for this lens space is twisted shut (folded closed with a twist).

Returns
  `true` if and only if the torus is twisted shut.

std::ostream& regina::NLayeredLensSpace::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream& regina::NLayeredLensSpace::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NLayeredLensSpace::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nlayeredlensspace.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).